Attribute VB_Name = "Module2"
'----------------------------------------------------------------------------
'
' MIDI Programmer's ToolKit for Windows - DECLARES.BAS
' Visual Basic Constants and Function Declarations
'
' Copyright (c) Paul A. Messick, 1994-1995
'
'----------------------------------------------------------------------------

' MIDISYS.DLL Function and Data Declarations

' MIDISYS Constants
' midi buffer sizes
Global Const QUEUE_64 = 0
Global Const QUEUE_128 = &H1000
Global Const QUEUE_256 = &H2000
Global Const QUEUE_512 = &H3000
Global Const QUEUE_1K = &H4000
Global Const QUEUE_2K = &H5000
Global Const QUEUE_4K = &H6000
Global Const QUEUE_8K = &H7000
Global Const QUEUE_16K& = &H8000
Global Const QUEUE_32K = &H9000

Global Const SXBUF_64 = &H0
Global Const SXBUF_128 = &H100
Global Const SXBUF_256 = &H200
Global Const SXBUF_512 = &H300
Global Const SXBUF_1K = &H400
Global Const SXBUF_2K = &H500
Global Const SXBUF_4K = &H600
Global Const SXBUF_8K = &H700
Global Const SXBUF_16K = &H800
Global Const SXBUF_32K = &H900

' Sync Timer definitions
Global Const USE_CURRENT = &HFFFF
Global Const DEFAULT_TIMERPERIOD = 10
Global Const MAX_RESOLUTION = 960
Global Const S_INT = 0
Global Const S_CLOCK = 1

' midi sync status messages
Global Const NOTEOFF = &H80
Global Const NOTEON = &H90
Global Const SYSEX = &HF0
Global Const MTC_QFRAME = &HF1
Global Const EOX = &HF7
Global Const MIDI_CLOCK = &HF8
Global Const MIDI_START = &HFA
Global Const MIDI_CONTINUE = &HFB
Global Const MIDI_STOP = &HFC

' external (user settable) flags
Global Const ENABLE_SYSEX = &H10000
Global Const DISABLE_SYSEX = Not ENABLE_SYSEX
Global Const SYNC_INPUT = &H20000
Global Const SYNC_OUTPUT = &H20000

Global Const MIDIIN_DEFAULT = QUEUE_512 Or SXBUF_32K Or ENABLE_SYSEX Or 32
Global Const MIDIOUT_DEFAULT = QUEUE_512 Or SXBUF_32K Or ENABLE_SYSEX Or 32

Global Const MAXPNAMELEN = 32

' MidiEvent Structure
Type MidiEvent
        time As Long
        status As String * 1    'Note that these elements of the MidiEvent
        data1 As String * 1     'structure are declared as fixed length strings
        data2 As String * 1     'of length 1.  This is because these elements
        data3 As String * 1     'are actually single bytes.
End Type


' MIDI Output Functions
'BOOL GetMidiOutDescription(UINT wDeviceID, LPSTR lpzDesc);
Declare Function GetMidiOutDescription Lib "midisys.dll" (ByVal wDeviceID%, ByVal lpzDesc$) As Integer

'UINT OpenMidiOut(LPMIDIOUT FAR* lpMidiOut, HWND hWnd, UINT wDeviceID, LPSYNC lpSync, DWORD dwFlags);
Declare Function OpenMidiOut Lib "midisys.dll" (lpMidiOut&, ByVal hWnd%, ByVal wDeviceID%, LPSYNC As Any, ByVal dwFlags&) As Integer

'UINT ResetMidiOut(LPMIDIOUT lpMidiOut);
Declare Function ResetMidiOut Lib "midisys.dll" (ByVal lpMidiOut&) As Integer

'void FlushMidiOut(LPMIDIOUT lpMidiOut);
Declare Sub FlushMidiOut Lib "midisys.dll" (ByVal lpMidiOut&)

'UINT CloseMidiOut(LPMIDIOUT FAR* lpMidiOut);
Declare Function CloseMidiOut Lib "midisys.dll" (lpMidiOut&) As Integer

'UINT PutMidiOut(LPMIDIOUT lpMidiOut, LPMIDIEVENT lpMidiEvent);
Declare Function PutMidiOut Lib "midisys.dll" (ByVal lpMidiOut&, lpMidiEvent As MidiEvent) As Integer


' MIDI Input Functions
'BOOL GetMidiInDescription(UINT wDeviceID, LPSTR lpzDesc);
Declare Function GetMidiInDescription Lib "midisys.dll" (ByVal wDeviceID%, ByVal lpzDesc$) As Integer

'UINT OpenMidiIn(LPMIDIIN FAR* lpMidiIn, HWND hWnd, UINT wDeviceID, LPSYNC lpSync, DWORD dwFlags);
Declare Function OpenMidiIn Lib "midisys.dll" (lpMidiIn&, ByVal hWnd%, ByVal wDeviceID%, LPSYNC As Any, ByVal dwFlags&) As Integer

'UINT StartMidiIn(LPMIDIIN lpMidiIn);
Declare Function StartMidiIn Lib "midisys.dll" (ByVal lpMidiIn&) As Integer

'UINT StopMidiIn(LPMIDIIN lpMidiIn);
Declare Function StopMidiIn Lib "midisys.dll" (ByVal lpMidiIn&) As Integer

'UINT CloseMidiIn(LPMIDIIN FAR* lpMidiIn);
Declare Function CloseMidiIn Lib "midisys.dll" (lpMidiIn&) As Integer

'LPMIDIEVENT GetMidiIn(LPMIDIIN lpMidiIn);
Declare Function GetMidiIn Lib "midisys.dll" (ByVal lpMidiIn&) As Long


' Syncronization Functions
'UINT OpenSync(LPSYNC FAR *lpSync, HWND hWnd, UINT mode, UINT timerPeriod);
Declare Function OpenSync Lib "midisys.dll" (LPSYNC&, ByVal hWnd%, ByVal mode%, ByVal timerPeriod%) As Integer

'UINT CloseSync(LPSYNC FAR* lpSync);
Declare Function CloseSync Lib "midisys.dll" (LPSYNC&) As Integer

'void StopSync(LPSYNC lpSync);
Declare Sub StopSync Lib "midisys.dll" (ByVal LPSYNC&)

'void PauseSync(LPSYNC lpSync, BOOL reset);
Declare Sub PauseSync Lib "midisys.dll" (ByVal LPSYNC&, ByVal mreset%)

'void StartSync(LPSYNC lpSync);
Declare Sub StartSync Lib "midisys.dll" (ByVal LPSYNC&)

'void ReStartSync(LPSYNC lpSync);
Declare Sub ReStartSync Lib "midisys.dll" (ByVal LPSYNC&)

'UINT SetTempo(LPSYNC lpSync, DWORD uSPerBeat);
Declare Function SetTempo Lib "midisys.dll" (ByVal LPSYNC&, ByVal uSPerBeat As Long) As Integer

'void SetResolution(LPSYNC lpSync, UINT resolution);
Declare Sub SetResolution Lib "midisys.dll" (ByVal LPSYNC&, ByVal resolution%)

'DWORD GetTempo(LPSYNC lpSync);
Declare Function GetTempo Lib "midisys.dll" (ByVal LPSYNC&) As Long

'UINT GetResolution(LPSYNC lpSync);
Declare Function GetResolution Lib "midisys.dll" (ByVal LPSYNC&) As Integer


' CPtrToMidiEvent Conversion Function Declaration
Declare Sub CPtrToMidiEvent Lib "tkcc.vbx" (lpDest As MidiEvent, ByVal lpSrc As Long)

' CPtrToVBString Conversion Function Declaration
Declare Sub CPtrToVBString Lib "tkcc.vbx" (ByVal lpDest$, ByVal lpSrc&, ByVal Length&)

